﻿(function ($) {
    var vinehost = "https://vine.eu"
    async function GetToken(apikey) {
        return fetch(`${vinehost}/api/rest/2.0/login`, { 
                headers: { 'x-api-key': apikey}
        })
        .then((response) => {
            return response.text();
        });
    }
    async function GetOrganizationId(token, apikey) {
        const res = await fetch(`${vinehost}/api/rest/2.0/vy_user?$authtoken=${token}`).then((response) => {
            return response.text();
        });
        parser = new DOMParser();
        xmlDoc = parser.parseFromString(res,"text/xml");
        const organizationId = xmlDoc.getElementsByTagName('d:ORGANIZATIONID')[0].textContent;
        return organizationId;
    }

    async function VineMaOAuthHandler(e) {
        if(e.data.message && e.data.message == 'ma_joomla_token') {
            var apikey = e.data.token;

            var token = await GetToken(apikey);

            if(!token || token.toLowerCase() == 'unauthorized')
                return;
            
            var orgId = await GetOrganizationId(token, apikey);

            if(authWindow)
                authWindow.close();

            var $apikeyField = $('#jform_params_api_key');
            $apikeyField.val(apikey);
            var $orgIdField = $('#jform_params_organization_id');
            $orgIdField.val(orgId);
            $('#toolbar-apply button').click();
        }
    }

    window.removeEventListener('message', VineMaOAuthHandler);
    window.addEventListener('message', VineMaOAuthHandler);
    
    var authWindow;
    
    window.openMaLoginWindow = function() {
        authWindow = window.open(`${vinehost}/ma/oauth?appName=Joomla`, 'mywindow', 'toolbar=no, menubar=no, width=600, height=500');
    }
    
    window.logoutFromMA = function() {
        var $apikeyField = $('#jform_params_api_key');
        $apikeyField.val('');
        var $orgIdField = $('#jform_params_organization_id');
        $orgIdField.val('');
        $('#toolbar-apply button').click();
    }
})(jQuery);